<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

class AntiAspi_maintain extends PluginMaintain
{
  private $installed = false;

  function __construct($plugin_id)
  {
    parent::__construct($plugin_id);
  }

  function install($plugin_version, &$errors=array())
  {
    global $prefixeTable;

    // table antiaspi_ip_ban to store list of banned IP addresses
    $result = pwg_query('SHOW TABLES LIKE "'.$prefixeTable.'antiaspi_ip_ban";');
    if (!pwg_db_num_rows($result))
    {
      $query = "
CREATE TABLE " . $prefixeTable . "antiaspi_ip_ban (
  id int(11) NOT NULL auto_increment,
  ip char(50) NOT NULL default '',
  date char(20) NOT NULL default '',
  PRIMARY KEY (id),
  KEY ip (ip)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
;";
      pwg_query($query);
    }

    // table antiaspi_log to store a specific "short-term" log
    // (ENGINE=MEMORY, specific)
    $result = pwg_query('SHOW TABLES LIKE "'.$prefixeTable.'antiaspi_log";');
    if (!pwg_db_num_rows($result))
    {
      $query = "
CREATE TABLE " . $prefixeTable . "antiaspi_log (
  IP varchar(15) NOT NULL default '',
  occured_on datetime NOT NULL,
  image_id mediumint(8) default NULL,
  category_id smallint(5) default NULL
) ENGINE=MEMORY DEFAULT CHARSET=utf8
;";
      pwg_query($query);
    }

    $this->installed = true;
  }

  function activate($plugin_version, &$errors=array())
  {
    if (!$this->installed)
    {
      $this->install($plugin_version, $errors);
    }
  }

  function deactivate()
  {
  }

  function uninstall()
  {
    global $prefixeTable;

    pwg_query('DROP TABLE '.$prefixeTable.'antiaspi_ip_ban;');
    pwg_query('DROP TABLE '.$prefixeTable.'antiaspi_log;');
  }
}
?>